// JavaScript
var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var teams_url = "http://cricketfox.mozdev.org/cfteams.xml";
function optionsLoad()
{
  gOptions = new OptionsModule();
  gOptions.loadPrefs();
}

function optionsUnload()
{
  gOptions = null;
}

function OptionsModule()
{
  this.wrappedJSObject = this;
  return this;
}

OptionsModule.prototype = {

	load_xml: function(url)
	{
		request = new XMLHttpRequest();
		request.onreadystatechange = this.process_request;
		request.open("GET", url, true);  
  		request.send(null);
	},
	
	process_request: function()
	{
		var response;
  		if (request.readyState == 4 && request.status == 200) {
			elem = document.getElementById("cf-teams");
		 	while (elem.hasChildNodes())
    		  	elem.removeChild(elem.lastChild);
			response = request.responseXML;
			var teams = response.getElementsByTagName('team');
			var favTeam = prefService.getCharPref("extensions.cricketfox.favTeam");
			var selIndex = 0;
			for(var loop=0;loop < teams.length;loop++){
			      var menuitem = document.createElement("menuitem");
				  var value = teams[loop].firstChild.data;
				  if(value == favTeam){
					selIndex=loop;
				  }
				  menuitem.setAttribute("label",value);
				  elem.appendChild(menuitem);
			}
			var selInterval = 0;
			var favInterval = prefService.getIntPref("extensions.cricketfox.updateInterval")/60000;
			elem = document.getElementById("cf-interval").getElementsByTagName("menuitem");
			for(var loop=0;loop < elem.length;loop++){
				  var value = elem[loop].label;
				  if(value == favInterval){
					selInterval=loop;
				  }
			}
			document.getElementById("cf-interval-menulist").selectedIndex = selInterval;
			document.getElementById("cf-teams-menulist").selectedIndex = selIndex;
  		}
	},
	
	loadPrefs: function(){
		this.load_xml(teams_url);
	},
	
	buttonOk : function(){
		this.savePrefs();
	    window.close();
	},
	
	buttonCancel : function(){
		window.close();
	},
	
	savePrefs: function() {
		var selectedTeam = document.getElementById("cf-teams-menulist").selectedItem.label;
		var updateInterval = document.getElementById("cf-interval-menulist").selectedItem.label;
		try{
			prefService.setCharPref("extensions.cricketfox.favTeam",selectedTeam);
		}catch(e){}
		try{
			prefService.setIntPref("extensions.cricketfox.updateInterval",(updateInterval*60000));
		}catch(e){}		
	}
}